//  QUXKinput.cpp version 1.0
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998  Gaspar Sinai
// 
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
//
#include "QUXKinput.h"


QUXKinput::QUXKinput (QUWidget* widgetIn, UWidgetX* uwidgetIn) : UXKinput (uwidgetIn)
{
	int	i;

	for (i=0; i<U_MAX_EVENT; i++)
	{
		handlers[i] = False;
	}
	widget = widgetIn;
}

QUXKinput::~QUXKinput()
{
	int	i;
	uEnd ();
	for (i=0; i<U_MAX_EVENT; i++)
	{
		if (handlers[i] == True) removeEventHandler ((UInputEvent)i);
	}
}

void
QUXKinput::addEventHandler (const UInputEvent eventType)
{
	switch (eventType)
	{
	case	UPROPERTY_CHANGE:
		if (handlers[eventType] == True) return;
		widget->uAddEventHadler (this, UPROPERTY_CHANGE);
		handlers[eventType] = True;
		break;
	case 	UNO_EVENT:
		if (handlers[eventType] == True) return;
		widget->uAddEventHadler (this, UNO_EVENT);
		handlers[eventType] = True;
		break;
	default:
		cerr << "error: QUXKinput::addEventHandler unknown event type"
			<< eventType << ".\n";
	}
	return;
}

void
QUXKinput::removeEventHandler (const UInputEvent eventType)
{
	switch (eventType)
	{
	case	UPROPERTY_CHANGE:
		if (handlers[eventType] == False) return;
		widget->uRemoveEventHadler (this, UPROPERTY_CHANGE);
		handlers[eventType] = False;
		break;
	case 	UNO_EVENT:
		if (handlers[eventType] == False) return;
		widget->uRemoveEventHadler (this, UNO_EVENT);
		handlers[eventType] = False;
		break;
	default:
		cerr << "error: QUXKinput::addEventHandler unknown event type"
			<< eventType << ".\n";
	}
	return;
}

